﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace Pcb
{
    //Einfache Klasse die ein DoubleBuffer Panel darstellt
    class PanelHelper : Panel
    {   
        public PanelHelper()
        {
            this.DoubleBuffered = true;
        }
    }

    class ExPanelHelper : Panel
    {
        float zoom;
        List<PanelItem> items;
        public ExPanelHelper(Form parent)
        {
            this.DoubleBuffered = true;
            zoom = 1;
            items = new List<PanelItem>();
            MouseWheel += new MouseEventHandler(PanelHelper_MouseWheel);
            parent.MouseWheel += new MouseEventHandler(PanelHelper_MouseWheel);
        }
        private void PanelHelper_MouseWheel(object sender, MouseEventArgs e)
        {
            if (e.Delta > 0)
                zoom *= ((float)e.Delta) / 100f;
            if (e.Delta < 0)
                zoom /= ((float)-e.Delta) / 100f;
            Console.WriteLine(zoom);
            Refresh();
        }
        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            for (int i = 0; i < items.Count; i++)
                items[i].Draw(e.Graphics, zoom);
        }
        public List<PanelItem> Items
        {
            get
            {
                return items;
            }
            set
            {
                items = value;
            }
        }
    }
    abstract class PanelItem
    {
        public virtual void Draw(Graphics g, float zoom)
        {

        }
    }
}
